import { jsonError } from "../../common.js";

export async function onRequestPost(context: RequestContext) {
  const { user, name } = context.data.body;

  if (!user) return jsonError("No user provided", 400);

  if (typeof name !== "string" || name.length > 32)
    return jsonError("Invalid name", 400);

  const existingUser = await context.env.DATA.get(`gamemod_${user}`);

  if (existingUser) return jsonError("Cannot add an existing user", 400);

  if (
    ["165594923586945025", "289372404541554689", "396347223736057866"].includes(
      user,
    )
  )
    return new Response(null, {
      status: 204,
    });

  if (!user.match(/^\d{17,19}$/)) return jsonError("Invalid User ID", 400);

  const data = {
    created_at: Date.now(),
    created_by: context.data.current_user.id,
    id: user,
    name,
  };

  await context.env.DATA.put(`gamemod_${user}`, JSON.stringify(data), {
    metadata: data,
  });

  return new Response(null, {
    status: 204,
  });
}
